/*
 * GccApplication1.c
 *
 * Created: 5/12/2019 12:18:16 PM
 * Author : Last
 */ 

#define F_CPU 16000000
#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>


#define DELAY 7
#define DELAY1 8
#define DELAY2 4

void Z_UP(int steps) {
	int i;
	
	PORTA &= ~(1 << PA6);//dir
	PORTA &= ~(1 << PA7);//en
	
	for (i = 0; i < steps; i++) {
		PORTA |= (1 << PA5);//step
		_delay_ms(DELAY);
		PORTA &= ~(1 << PA5);
		_delay_ms(DELAY);
	}
	PORTA |= (1 << PA7);
}

void Z_DOWN(int steps) {
	int i;
	
	PORTA |= (1 << PA6);//dir
	PORTA &= ~(1 << PA7);//en
	
	for (i = 0; i < steps; i++) {
		PORTA |= (1 << PA5);//step
		_delay_ms(DELAY);
		PORTA &= ~(1 << PA5);
		_delay_ms(DELAY);
	}
		PORTA |= (1 << PA7);
}

void Y_FORWARD(int steps) {
	int i;
	
	PORTB &= ~(1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY);
		PORTB &= ~(1 << PB5);
		_delay_ms(DELAY);
	}
	PORTB |= (1 << PB7);
}

void X_star1(int steps){
	int i;
	PORTC &= ~(1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB &= ~(1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
		
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		PORTC |= (1 << PC5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PC5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star2(int steps){
	int i;
	PORTC &= ~(1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB &= ~(1 << PB6);//dir y forward
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		PORTC |= (1 << PB5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PB5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star3(int steps){
	int i;
	PORTC |= (1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
    PORTB &= ~(1 << PB6);//dir y forward
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		PORTC |= (1 << PB5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PB5);

	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star4(int steps){
	int i;
	PORTC |= (1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB &= ~(1 << PB6);//dir y forward
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		PORTC |= (1 << PC5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PC5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star5(int steps){
	int i;
	PORTC |= (1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB |= (1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		PORTC |= (1 << PC5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PC5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star6(int steps){
	int i;
	PORTC |= (1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB |= (1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		PORTC |= (1 << PB5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PB5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star7(int steps){
	int i;
	PORTC &= ~(1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB |= (1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PC5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PC5);
		PORTC |= (1 << PB5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PB5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void X_star8(int steps){
	int i;
	PORTC &= ~(1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	PORTB |= (1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		_delay_ms(DELAY2);
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY2);
		PORTB &= ~(1 << PB5);
		PORTC |= (1 << PC5);//step
		_delay_ms(DELAY1);
		PORTC &= ~(1 << PC5);
	}
	PORTB |= (1 << PB7);
	PORTC |= (1 << PC7);
}

void Y_BACKWARD(int steps) {
	int i;
	
	PORTB |= (1 << PB6);//dir
	PORTB &= ~(1 << PB7);//en
	
	for (i = 0; i < steps; i++) {
		PORTB |= (1 << PB5);//step
		_delay_ms(DELAY);
		PORTB &= ~(1 << PB5);
		_delay_ms(DELAY);
	}
	PORTB |= (1 << PB7);
}

void X_RIGHT(int steps) {
	int i;
	
	PORTC &= ~(1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	
	for (i = 0; i < steps; i++) {
		PORTC |= (1 << PC5);//step
		_delay_ms(DELAY);
		PORTC &= ~(1 << PC5);
		_delay_ms(DELAY);
	}
	PORTC |= (1 << PC7);
}

void X_LEFT(int steps) {
	int i;
	
	PORTC |= (1 << PC6);//dir
	PORTC &= ~(1 << PC7);//en
	
	for (i = 0; i < steps; i++) {
		PORTC |= (1 << PC5);//step
		_delay_ms(DELAY);
		PORTC &= ~(1 << PC5);
		_delay_ms(DELAY);
	}
	PORTC &= ~(1 << PC7);
}

ISR(PCINT1_vect){
	static int power_up = 1;
	PORTD |= (1 << PD7);
				
	if((PINB &(1 << PB2)) == 0){
		if(power_up){ // butonul de extrudare al pen-ului se apasa o data pentru alegerea materialului si inca o data pentru pornirea incalzirii, releul face partea asta dar nu si extrudeaza material :/
			PORTD |= (1 << PD5);
			_delay_ms(200);
			PORTD &= ~(1 << PD5);
			_delay_ms(200);
			PORTD |= (1 << PD5);
			_delay_ms(200);
			PORTD &= ~(1 << PD5);
			power_up = 0;
			_delay_ms(5000);// asteapta incalzirea pen-ului	
		}else{
		_delay_ms(1000);
		if((PINB &(1 << PB2)) == 0){ // daca se apasa BTN pentru  mai mult de 1 sec se modeleaza un patrat, altfel romb ... adica stea desi e romb...
		//cube nope :/
		/*
		PORTD |= (1 << PD0);
		X_RIGHT(100);
		Y_FORWARD(100);
		X_LEFT(100);
		Y_BACKWARD(100);
		Z_UP(100);
		PORTD &= ~(1 << PD0);
		X_RIGHT(100);
		Z_DOWN(100);
		PORTD |= (1 << PD0);
		Z_UP(100);
		PORTD &= ~(1 << PD0);
		Y_FORWARD(100);
		Z_DOWN(100);
		PORTD |= (1 << PD0);
		Z_UP(100);
		PORTD &= ~(1 << PD0);
		X_LEFT(100);
		Z_DOWN(100);
		PORTD |= (1 << PD0);
		Z_UP(100);
		PORTD &= ~(1 << PD0);
		Y_BACKWARD(100);
		Z_DOWN(100);
		PORTD |= (1 << PD0);
		Z_UP(100);
		X_RIGHT(100);
		Y_FORWARD(100);
		X_LEFT(100);
		Y_BACKWARD(100);
		PORTD &= ~(1 << PD0);*/	
		
		//square
			PORTD |= (1 << PD5);
			_delay_ms(7000);
			X_RIGHT(100);
			Y_FORWARD(100);
			X_LEFT(100);
			Y_BACKWARD(100);
			Z_UP(2);
			X_RIGHT(100);
			Y_FORWARD(100);
			X_LEFT(100);
			Y_BACKWARD(100);
			Z_UP(2);
			X_RIGHT(100);
			Y_FORWARD(100);
			X_LEFT(100);
			Y_BACKWARD(100);
			Z_UP(2);
			X_RIGHT(100);
			Y_FORWARD(100);
			X_LEFT(100);
			Y_BACKWARD(100);
			Z_UP(2);
			X_RIGHT(100);
			Y_FORWARD(100);
			X_LEFT(100);
			Y_BACKWARD(100);
			Z_UP(2);
			X_RIGHT(100);
			Y_FORWARD(100);
			X_LEFT(100);
			Y_BACKWARD(100);
			PORTD &= ~(1 << PD5);
		}else{
		//star... yeye
		    PORTD |= (1 << PD5);
			_delay_ms(7000);
			X_star1(30);
			X_star2(30);
			X_star3(30);
			X_star4(30);
			X_star5(30);
			X_star6(30);
			X_star7(30);
			X_star8(30);
			Z_UP(2);
			X_star1(30);
			X_star2(30);
			X_star3(30);
			X_star4(30);
			X_star5(30);
			X_star6(30);
			X_star7(30);
			X_star8(30);
			Z_UP(2);
			X_star1(30);
			X_star2(30);
			X_star3(30);
			X_star4(30);
			X_star5(30);
			X_star6(30);
			X_star7(30);
			X_star8(30);
			PORTD &= ~(1 << PD5);		
			}
		}
	}
	
	PORTD &= ~(1 << PD7);
}


void init() {
	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB2);
	
	PCMSK1 |= (1 << PCINT10);
	PCICR |= (1 << PCIE1);
	
	DDRC |= (1 << PC7);// x
	PORTC |= (1 << PC7); //en
	DDRC |= (1 << PC6); // dir
	DDRC |= (1 << PC5); // step
	
	DDRD |= (1 << PD7);// semnalizeaza functionarea
	
	DDRA |= (1 << PA7);// z
	PORTA |= (1 << PA7); //en
	DDRA |= (1 << PA6); // dir
	DDRA |= (1 << PA5); // step
	
	DDRB |= (1 << PB7);// y
	PORTB |= (1 << PB7); //en
	DDRB |= (1 << PB6); // dir
	DDRB |= (1 << PB5); // step
	
	DDRD |=(1 <<PD5);//init pen

}

int main(void){
	init();
	sei();

	while(1);
	
return 0;
}

